/***************************************************************************
                          optionsdialog.cpp  -  description
                             -------------------
    begin                : Sun Jul 23 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id: optionsdialog.cpp,v 1.1 2000/07/23 19:58:42 js Exp $
 *
 */

#include "k8ktest.h"

OptionsDialog::OptionsDialog(QWidget *parent,char *label)
		: QDialog ( parent, label, TRUE )
{
	ApplicationWindow *appwind=(ApplicationWindow*)parent;
	
	/* vars to size things */
	int label_x_offset=20;
	int label_y_offset=20;
	int label_len=100;
	int label_hi=20;
	int label_spacing=5;
	
	int text_x_offset=label_x_offset+label_len+10;
	int text_y_offset=label_y_offset;
	int text_len=50;
	int text_hi=20;
	int text_spacing=label_spacing;
	
	this->setCaption ( "Options" ) ;
	
	/* buttons */
	ok = new QPushButton( "Ok", this );
	cancel = new QPushButton( "Cancel", this );
	
	/* text boxes */
	i2cbusdelay = new QLineEdit(this,"i2cbusdelay");
	lptport = new QLineEdit(this,"lptport");
	refreshrate = new QLineEdit(this,"refreshrate");

	/* labels */
	l_i2cbusdelay = new QLabel(QString("I2C Busdelay"),this,"l_i2cbusdelay");
	l_lptport = new QLabel(QString("LPT port"),this,"l_lptport");
	l_refreshrate = new QLabel(QString("Refresh rate (ms)"),this,"l_refreshrate");

	/* set the geometries */
	l_i2cbusdelay->setGeometry(label_x_offset,label_y_offset,label_len,label_hi);
	l_lptport->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*1,label_len,label_hi);
	l_refreshrate->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*2,label_len,label_hi);

	i2cbusdelay->setGeometry(text_x_offset,text_y_offset,text_len,text_hi);
	lptport->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*1,text_len,text_hi);
	refreshrate->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*2,text_len,text_hi);

	ok->setGeometry(label_x_offset,text_y_offset+(text_hi+text_spacing)*4,100,25);
	cancel->setGeometry(label_spacing+label_x_offset+100,text_y_offset+(text_hi+text_spacing)*4,100,25);
	
	ok->setDefault(TRUE);
	connect( ok, SIGNAL(clicked()), SLOT(accept()) );
	connect( cancel, SIGNAL(clicked()), SLOT(reject()) );
	
	/* fill the textboxes with current values */
	i2cbusdelay->setText(tr("%1").arg( appwind->settings->i2cbusdelay));
	lptport->setText(tr("%1").arg( appwind->settings->lptport));
	refreshrate->setText(tr("%1").arg( appwind->settings->refreshrate));
}

OptionsDialog::~OptionsDialog()
{
	emit this->Closed();
}

void OptionsDialog::resizeEvent(QResizeEvent * r_event)
{
	QDialog::resizeEvent(r_event);
	this->setMaximumSize(this->size());
	this->setMinimumSize(this->size());
}

void OptionsDialog::hideEvent(QHideEvent *h)
{
	emit this->Closed();
	QDialog::hideEvent(h);
}
